<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The following parameters are used to compute the nutrients provided by a previous meadow or lucerne.</translate>
          </q-banner>

          <q-card-section>
            <div>
              <div class="text-grey-8 q-mb-xs">
                <translate>Was there a meadow before the main crop or the intermediate crop?</translate>
              </div>
              <q-btn-toggle
                v-model="storeIntermediateCropHadMeadow"
                :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                toggle-color="primary"
              />
            </div>

            <q-select
              v-if="storeIntermediateCropHadMeadow"
              v-model="storeIntermediateCropMeadowAge"
              :options="meadowAgeOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="isLoading"
              :label="$gettext('Meadow age')"
              class="q-mt-md"
            />

            <q-select
              v-if="storeIntermediateCropHadMeadow"
              v-model="storeIntermediateCropMeadowDestructionSeason"
              :options="meadowDestructionSeasonOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="isLoading"
              :label="$gettext('Meadow destruction season')"
              class="q-mt-md"
            />

            <q-select
              v-if="storeIntermediateCropHadMeadow"
              v-model="storeIntermediateCropMeadowRank"
              :options="meadowRankOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="isLoading"
              :label="$gettext('Meadow rank')"
              class="q-mt-md"
            />
          </q-card-section>

          <q-card-section>
            <div>
              <div class="text-grey-8 q-mb-xs">
                <translate>Was there lucerne before the main crop or the intermediate crop?</translate>
              </div>
              <q-btn-toggle
                v-model="storeIntermediateCropHadLucerne"
                :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                toggle-color="primary"
              />
            </div>

            <q-select
              v-if="storeIntermediateCropHadLucerne"
              v-model="storeIntermediateCropLucerneAge"
              :options="lucerneAgeOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="isLoading"
              :label="$gettext('Lucerne age')"
              class="q-mt-md"
            />

            <q-select
              v-if="storeIntermediateCropHadLucerne"
              v-model="storeIntermediateCropLucerneRank"
              :options="lucerneRankOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="isLoading"
              :label="$gettext('Lucerne rank')"
              class="q-mt-md"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import queryRequafertiConfig from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiConfig'

export default {
  name: 'RequafertiMeadowAndLucernePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, RequafertiI18nMixin],
  data () {
    return {
      requafertiConfig: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Meadow and lucerne')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    canContinue () {
      return this.isParameterSet(this.storeIntermediateCropHadMeadow) &&
        (!this.storeIntermediateCropHadMeadow || (this.isParameterSet(this.storeIntermediateCropMeadowAge) && this.isParameterSet(this.storeIntermediateCropMeadowDestructionSeason) && this.isParameterSet(this.storeIntermediateCropMeadowRank))) &&
        this.isParameterSet(this.storeIntermediateCropHadLucerne) &&
        (!this.storeIntermediateCropHadLucerne || (this.isParameterSet(this.storeIntermediateCropLucerneAge) && this.isParameterSet(this.storeIntermediateCropLucerneRank)))
    },
    isLoading () {
      return !this.requafertiConfig
    },
    meadowAgeOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['age_prairie'] || []
    },
    meadowDestructionSeasonOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['saison_destruction'] || []
    },
    meadowRankOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['rang_prairie'] || []
    },
    lucerneAgeOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['age_luzerne'] || []
    },
    lucerneRankOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['rang_luzerne'] || []
    },
    storeIntermediateCropHadMeadow: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropHadMeadow
      },
      set (v) {
        this.updateParameter('intermediateCropHadMeadow', v)
      }
    },
    storeIntermediateCropMeadowAge: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropMeadowAge
      },
      set (v) {
        this.updateParameter('intermediateCropMeadowAge', v)
      }
    },
    storeIntermediateCropMeadowDestructionSeason: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropMeadowDestructionSeason
      },
      set (v) {
        this.updateParameter('intermediateCropMeadowDestructionSeason', v)
      }
    },
    storeIntermediateCropMeadowRank: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropMeadowRank
      },
      set (v) {
        this.updateParameter('intermediateCropMeadowRank', v)
      }
    },
    storeIntermediateCropHadLucerne: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropHadLucerne
      },
      set (v) {
        this.updateParameter('intermediateCropHadLucerne', v)
      }
    },
    storeIntermediateCropLucerneAge: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropLucerneAge
      },
      set (v) {
        this.updateParameter('intermediateCropLucerneAge', v)
      }
    },
    storeIntermediateCropLucerneRank: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropLucerneRank
      },
      set (v) {
        this.updateParameter('intermediateCropLucerneRank', v)
      }
    },
    storePreviousCropExists () {
      return this.$store.state.fertilizationPlan.parameters.previousCropExists
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadConfig('cache-first')

    // Refresh online data (do not wait until completion)
    this.loadConfig('network-only')
  },
  methods: {
    onClickNext () {
      // reset linked fields if hadMeadow is false
      if (!this.storeIntermediateCropHadMeadow) {
        this.storeIntermediateCropMeadowAge = null
        this.storeIntermediateCropMeadowDestructionSeason = null
        this.storeIntermediateCropMeadowRank = null
      }

      // reset linked fields if hadLucerne is false
      if (!this.storeIntermediateCropHadLucerne) {
        this.storeIntermediateCropLucerneAge = null
        this.storeIntermediateCropLucerneRank = null
      }

      this.$router.replace({
        name: 'requafertiOrganicManure'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'requafertiIntermediateCropProfile'
      })
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryRequafertiConfig,
        fetchPolicy
      })
      this.requafertiConfig = data?.requaferti__config
    }
  }
}
</script>
